//funkce volane pri obsluze formulare

//------------------------------------------------------------------------------
//deklarace funkci definovanych v jinych souborech
//------------------------------------------------------------------------------
procedure cbLabViewSet(idx:integer);
var s:string;
begin
  s:=IntToStr(idx+1)+'. ';
  if(aLab[idx].sName='') then s:=s+'(jmno LABky)'
  else s:=s+aLab[idx].sName;
  GgForm_cbLabView.Items[idx]:=s;
  GgForm_butLabVideo.Enabled:=(aLab[idx].sVideoId<>'');
  GgForm_butLabPicture.Enabled:=(aLab[idx].sImgUrl<>'');
  GgForm_butLabMessageAward.Enabled:=(aLab[idx].sMessageAward<>'');
  GgForm_butLabVideoAward.Enabled:=(aLab[idx].sVideoIdAward<>'');
  GgForm_butLabPictureAward.Enabled:=(aLab[idx].sImgUrlAward<>'');
  GgForm_butLabQuestion.Enabled:=(aLab[idx].sQuestion<>'');
  GgForm_butLabMapycz.Enabled:=(aLab[idx].sCoord<>'');
  GgForm_butLabOsm.Enabled:=(aLab[idx].sCoord<>'');
end;

procedure AddChangeType(sType:string); //prida typ zmeny
begin
  if(Pos(sType,GgForm_eChangeGpx.Text)>0) then exit; //tato zmena uz tam je
  if(GgForm_eChangeGpx.Text='') then GgForm_eChangeGpx.Text:=sType
  else GgForm_eChangeGpx.Text:=GgForm_eChangeGpx.Text+','+sType;
end;

//------------------------------------------------------------------------------
procedure lSearchDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
var s:string;
begin
  with GgForm_lSearch.Canvas do begin
    Brush.Color:=STYLE_BKGCOLOR_FOCUSED;
    if((State AND 1)=1) then begin
      Brush.Color:=STYLE_BKGCOLOR_SELECTED;
      Font.Color:=STYLE_COLOR_SELECTED;
    end;
    FillRect(Rect);
    s:=GgForm_lSearch.Items[Index];
    //mezery jsou pridany proto, aby se text neprekryval s pripadnou dlouhou polozkou pred nim
    TextOut(Rect.Left+2,Rect.Top,Fetch(s,'|'));   //GC kod
    TextOut(Rect.Left+70,Rect.Top,Fetch(s,'|'));   //jmeno serie
    TextOut(Rect.Left+315,Rect.Top,'   '+Fetch(s,'|'));   //stat
    TextOut(Rect.Left+415,Rect.Top,'   '+Fetch(s,'|'));   //kraj
    TextOut(Rect.Left+545,Rect.Top,'   '+Fetch(s,'|'));   //autor serie
  end;
end;

procedure EnableActions(sender:TObject);
begin
  GgForm_bGpx.Enabled:=(GgForm_eID.Text<>'') and (GgForm_eName.Text<>'') and
    (GgForm_eNick.Text<>'');
  GGForm_butGpx.Enabled:=(GgForm_bGpx.Checked) and (GgForm_bGpx.Enabled);
  GGForm_bUpload.Enabled:=(GgForm_bGpx.Checked) and (GgForm_bGpx.Enabled)
    and IsUploadEnabled();
  if(not GgForm_bGpx.Checked) then GgForm_bImport.Checked:=false;
  GgForm_bImport.Enabled:=(GgForm_bGpx.Checked) and (GgForm_bGpx.Enabled);
  GgForm_bExist.Enabled:=GgForm_bImport.Checked;
end;

procedure butFceOtherOnClick(sender:TObject);
begin
  GgForm_pGpxFce.Visible:=(not GgForm_pGpxFce.Visible); //zmenime viditelneost panelu s funkcemi
end;

procedure SerieChange(sender:TObject);
var i:integer;
begin
  GgForm_bGpx.Checked:=true;
  EnableActions(nil);
  //pokud jde o zmenu poctu, musime upravit i seznam LABek k vyberu
  if(sender=GgForm_cbCount) then begin
    //doplnime chybejici radky
    for i:=GgForm_cbLabView.Items.Count+1 to GgForm_cbCount.ItemIndex+1 do begin
      //{$ifdef DEBUG_HELPER} LDH('pridavam '+IntToStr(i)); {$endif}
      cbLabViewSet(i-1);
    end;
    //vymazeme prebytecne radky
    for i:=GgForm_cbLabView.Items.Count-1 downto GgForm_cbCount.ItemIndex+1 do begin
      GgForm_cbLabView.Items.Delete(i);
    end;
  end;
  if(GgForm_bGgView.Checked) then begin
    if(sender=GgForm_eId) then AddChangeType('GC');
    //if(sender=GgForm_eCoord) then AddChangeType('COORD');  to se zmenit nema jak
    if(sender=GgForm_bBonus) then AddChangeType('BON');
    if(sender=GgForm_bSeq) then AddChangeType('SEQ');
    if(sender=GgForm_bEvent) then AddChangeType('EVNT');
    if(sender=GgForm_bArchiv) then AddChangeType('ARCH');
  end;
  EnableActions(nil);
end;

procedure SaveLab(idx:integer);
var x,y:extended;
    i:integer;
begin
  //tady je vzdycky rovnost, protoze jmeno labky se prepise do aLab[idx].sName
  //pri zmene GgForm_eLabName, na kterem je onChcnge()
  //if(GgForm_bGGView.Checked) and (aLab[idx].sName<>Trim(GgForm_eLabName.Text)) then AddChangeType('NAME');
  i:=rCmpNew.Items[idx].idx;
  aLab[idx].sName:=Trim(GgForm_eLabName.Text);
  //prevedeme souradnice do obvykle podoby
  if(GgForm_eLabCoord.Text<>'') then begin
    ParseWgsStr(GgForm_eLabCoord.Text,x,y);
    GgForm_eLabCoord.Text:=FormatCoordNum(x,y);
  end;
  //{$ifdef DEBUG_HELPER} LDH('Lab_'+IntToStr(idx)+', COORD='+aLab[idx].sCoord+' / '+GgForm_eLabCoord.Text); {$endif}
  //if(GgForm_bGGView.Checked) and (aLab[idx].sCoord<>Trim(GgForm_eLabCoord.Text)) then AddChangeType('COORD');
  //{$ifdef DEBUG_HELPER} LDH('YYYYY 3'); {$endif}
  if(GgForm_bGGView.Checked) and (i>=0) and (aLabOld[i].sCoord<>Trim(GgForm_eLabCoord.Text)) then  begin
    //{$ifdef DEBUG_HELPER} LDH('YYYYY idx='+IntToStr(idx)+', i='+IntToStr(i)+','+aLabOld[i].sCoord+' <> '+GgForm_eLabCoord.Text); {$endif}
    AddChangeType('COORD');
  end;
  aLab[idx].sCoord:=Trim(GgForm_eLabCoord.Text);
  aLab[idx].sLabIdOrd:=Trim(GgForm_eLabIdOrd.Text);
  aLab[idx].iDiff:=GgForm_cbLabDiff.ItemIndex;
  aLab[idx].iTerr:=GgForm_cbLabTerr.ItemIndex;
  //if(GgForm_bGGView.Checked) and (aLab[idx].sText<>Trim(GgForm_mLabText.Lines.Text)) then AddChangeType('TXT');
  if(GgForm_bGGView.Checked) and (i>=0) and (aLabOld[i].sText<>Trim(GgForm_mLabText.Lines.Text)) then begin
    //{$ifdef DEBUG_HELPER} LDH('YYYYY idx='+IntToStr(idx)+', i='+IntToStr(i)+','+aLabOld[i].sText+' <> '+GgForm_mLabText.Lines.Text); {$endif}
    AddChangeType('TXT');
  end;
  aLab[idx].sText:=Trim(GgForm_mLabText.Lines.Text);
  //upravime spravne nabidku LABek s novym jmenem
  if(aLab[idx].sName<>'') then
    GgForm_cbLabView.Items[idx]:=IntToStr(iLab+1)+'. '+aLab[idx].sName;
  GgForm_bLabChange.Checked:=false;
end;

procedure LabChange(sender:TObject);
var i:integer;
begin
  GgForm_bLabChange.Checked:=true;
  if(sender=GgForm_eLabName) then begin //prepiseme jmeno do textu
    aLab[iLab].sName:=GgForm_eLabName.Text;
    i:=iLab;
    cbLabViewSet(iLab);
    GgForm_cbLabView.ItemIndex:=i;
  end;
end;

procedure ShowLab(idx:integer);
begin
  GgForm_eLabName.Text:=aLab[iLab].sName;
  GgForm_eLabCoord.Text:=aLab[iLab].sCoord;
  GgForm_eLabIdOrd.Text:=aLab[iLab].sLabIdOrd;
  GgForm_cbLabDiff.ItemIndex:=aLab[iLab].iDiff;
  GgForm_cbLabTerr.ItemIndex:=aLab[iLab].iTerr;
  GgForm_mLabText.Lines.Text:=aLab[iLab].sText;
  GgForm_butLabVideo.Enabled:=(aLab[idx].sVideoId<>'');
  GgForm_butLabPicture.Enabled:=(aLab[idx].sImgUrl<>'');
  GgForm_butLabMessageAward.Enabled:=(aLab[idx].sMessageAward<>'');
  GgForm_butLabVideoAward.Enabled:=(aLab[idx].sVideoIdAward<>'');
  GgForm_butLabPictureAward.Enabled:=(aLab[idx].sImgUrlAward<>'');
  GgForm_butLabQuestion.Enabled:=(aLab[idx].sQuestion<>'');
  GgForm_bLabChange.Checked:=false;
end;

procedure EnableUpDown;
begin
  GgForm_butLabUp.enabled:=(iLab>0);
  GgForm_butLabDown.enabled:=(iLab<GgForm_cbCount.ItemIndex);
end;

procedure cbLabViewOnChange(sender:TObject);
var i:integer;
  //pokud dojde ke zmene vybrane LABky, ulozi hodnoty predchozi a prepne na novou
begin
  //{$ifdef DEBUG_HELPER} LDH('aaa puvodni iLab='+IntToStr(iLab)); {$endif}
  if(GgForm_bLabChange.Checked) then SaveLab(iLab);
  //{$ifdef DEBUG_HELPER} LDH('bbb'); {$endif}
  iLab:=GgForm_cbLabView.ItemIndex;
  //{$ifdef DEBUG_HELPER} LDH('ccc iLab='+IntToStr(iLab)); {$endif}
  //pokud je iLab=-1, pak nedoslo ke zmene a je zobrazena stajna labka
  if(iLab=-1) then iLab:=i;
  ShowLab(iLab);
  //{$ifdef DEBUG_HELPER} LDH('ddd'); {$endif}
  EnableUpDown();
  //{$ifdef DEBUG_HELPER} LDH('eee'); {$endif}
end;

procedure cbLabViewInit;
var i:integer;
begin //prepise poradi a jmena labek do seznamu v combo
  for i:=0 to GgForm_cbCount.ItemIndex do cbLabViewSet(i);
  //aby nebyl problem s prazdnym seznamem kesi, vytvorime jednu simulovanou
  if(GgForm_cbLabView.Items.Count=0) then begin
    aLab[0].sName:='';
    aLab[0].sCoord:='';
    GgForm_cbLabView.Items.Add('');
    cbLabViewSet(0);
  end;
  GgForm_cbLabView.ItemIndex:=iLab;
  EnableUpDown();
end;

procedure cbApiRegionsOnChange(sender:TObject);
begin
  GgForm_pApiCoord.Visible:=(GgForm_cbApiRegions.ItemIndex=0);
  GgForm_pApiLabId.Visible:=(GgForm_cbApiRegions.ItemIndex=1);
  GgForm_pApiSmartLink.Visible:=(GgForm_cbApiRegions.ItemIndex=2);
  GgForm_butCountInCircles.Visible:=(GgForm_cbApiRegions.ItemIndex>2);
end;

procedure cbApiRegionsInit; //nacte seznam regionu pro vyber k hledani
var ini:TMemIniFile;
    aSec:TStringList;
begin //prepise poradi a jmena labek do seznamu v combo
  ini:=TMemIniFile.Create(GetMyDir()+'ApiRegions.ini');
  try
    aSec:=TStringList.Create();
    try
      ini.ReadSections(aSec);
      GgForm_cbApiRegions.Items.Text:=GgForm_cbApiRegions.Items.Text+aSec.Text;
    finally
      aSec.Free();
    end;
  finally
    ini.Free();
  end;
  GgForm_cbApiRegions.ItemIndex:=0;
  cbApiRegionsOnChange(nil);
end;

procedure butOwnerIdOnClick(sender:TObject);
var s,sJson:string;
    rJson:TSimpleJSon;
    iErr:integer;
begin
  s:=GgForm_eNick.Text;
  if(s='') then begin
    ShowMessage('Neni zadany nick autora!');
    exit;
  end;
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crHourglass;
{$ifdef DEBUG_HELPER} LDH('nick='+s); {$endif}
  s:='v1/users?usernames='+encodeurlelement(AnsiToUtf(s))+'&fields=referenceCode';
{$ifdef DEBUG_HELPER} LDH('6. url='+s); {$endif}
  iErr:=GcLiveRest('GET',s,'','',sJson);
  //StringToFile(sJson,GetMyDir()+'ApiUsersInfo.txt');
{$ifdef DEBUG_HELPER} LDH('iErr='+IntToStr(iErr)); {$endif}
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crDefault;
  if(iErr<>200) then begin
    ShowMessage('ERR: Chyba pri zjistovani ownerId.');
    exit;
  end;
  sJson:='{root:'+sJson+'}';
  rJson:=TSimpleJson.Create();
  try
    if(rJson.ParseString(sJson)) then begin
      s:=rJSon.AsString('root[0].referenceCode');
      GgForm_eOwnerId.Text:=IntToStr(GcApiCode2Num(s));
    end;
  finally
    rJson.Free();
  end;
  //{$ifdef DEBUG_HELPER} LDH('Konec Ownerid'); {$endif}
end;

procedure butLabCoordOnClick(sender:TObject);
var s:string;
    x,y:extended;
    b:boolean;
    g:TGeo;
begin
  s:=Trim(GgForm_eLabCoord.Text); //stavajici souradnice
{$ifdef DEBUG_HELPER} LDH('coord='+s); {$endif}
  if(s='') then begin
    //pokud je zadana rodicovska keska, pouzijeme jeji souradnice
    if(GgForm_eId.Text<>'') then begin
      {$ifdef DEBUG_HELPER} LDH('GC='+GgForm_eId.Text); {$endif}
      g:=TGeo.Create();
      try
        g.LoadByGc(GgForm_eId.Text);
        s:=g.GetCoord();
        {$ifdef DEBUG_HELPER} LDH('coord='+s); {$endif}
      finally
        g.Free();
      end;
    end else s:='5001.000; 1426.000'; //aby tam nejake byly
  end;
  ParseWgsStr(s,x,y);           //parsujeme
  {$ifdef DEBUG_HELPER} LDH('1 x='+FloatToStr(x)+', y='+FloatToStr(y)); {$endif}
  b:=CoordEdit('Souradnice LABky','',x,y);
  {$ifdef DEBUG_HELPER} LDH('2 x='+FloatToStr(x)+', y='+FloatToStr(y)); {$endif}
  if(b) then begin
    GgForm_eLabCoord.Text:=FormatCoordNum(x,y);
    LabChange(nil);
  end;
  GgForm_butLabMapycz.Enabled:=(GgForm_eLabCoord.Text<>'');
end;

procedure butLabUpOnClick(sender:TObject);
var pom:T_LAB;
    i:integer;
begin
  SaveLab(iLab);
  i:=iLab-1;
  pom:=aLab[iLab];
  aLab[iLab]:=aLab[i];
  aLab[i]:=pom;
  cbLabViewSet(iLab);
  cbLabViewSet(i);
  iLab:=i;
{$ifdef DEBUG_HELPER} LDH('set: 2'); {$endif}
  GgForm_cbLabView.ItemIndex:=iLab;
  ShowLab(iLab);
  EnableUpDown();
end;

procedure butLabDownOnClick(sender:TObject);
var pom:T_LAB;
    i:integer;
begin
  SaveLab(iLab);
  i:=iLab+1;
  pom:=aLab[iLab];
  aLab[iLab]:=aLab[i];
  aLab[i]:=pom;
  cbLabViewSet(iLab);
  cbLabViewSet(i);
  iLab:=i;
{$ifdef DEBUG_HELPER} LDH('set: 3'); {$endif}
  GgForm_cbLabView.ItemIndex:=iLab;
  ShowLab(iLab);
  EnableUpDown();
end;

procedure butLabDelOnClick(sender:TObject);
var i,n:integer;
begin
  if(iLab<0) then exit;
  SaveLab(iLab);
  i:=iLab;
  for n:=iLab to GgForm_cbLabView.Items.Count-2 do begin
    aLab[n]:=aLab[n+1];
    cbLabViewSet(n);
  end;
  GgForm_cbLabView.Items.Delete(GgForm_cbLabView.Items.Count-1);
  GgForm_cbCount.ItemIndex:=GgForm_cbLabView.Items.Count-1;
  if(i>GgForm_cbLabView.Items.Count-1) then begin
    i:=GgForm_cbLabView.Items.Count-1;
    cbLabViewSet(i);
  end;
  iLab:=i;
{$ifdef DEBUG_HELPER} LDH('del: 3'); {$endif}
  GgForm_cbLabView.ItemIndex:=iLab;
  ShowLab(iLab);
  EnableUpDown();
end;

procedure butImportOnClick(sender:TObject);  //import nove vytvarene serie
var sFile:string;
I:INTEGER;
begin
{$ifdef DEBUG_HELPER} LDH('butImportOnClick(): start'); {$endif}
  //sLabExist:='';
  i:=GgForm_cbLabView.ItemIndex;
  //butGpxOnClick(nil);
  if(sLabExist<>'') then begin
    ShowMessage('LAB kee ve vytvoenm GPX souboru ji v databzi existuj:'+CRLF+sLabExist
      +CRLF+CRLF+'Import souboru je peruen.');
//{$ifdef DEBUG_HELPER} LDH('set: 0'); {$endif}
    GgForm_cbLabView.ItemIndex:=i;
    exit;
  end;
//{$ifdef DEBUG_HELPER} LDH('set: 1'); {$endif}
  sFile:=GetLabFileName();
//{$ifdef DEBUG_HELPER} LDH('set: 2, sFile='+sFile); {$endif}
  if(FileExists(sFile)) then begin
    ProtStart();
    GeoImportBegin();
    GEOGET_DB.Start('LabForGg','');
    ImportGpxFile(sFile);
    GEOGET_DB.Commit('LabForGg');
    GeoImportEnd();
    ProtEnd();
  end;
//{$ifdef DEBUG_HELPER} LDH('set: 4'); {$endif}
  GgForm_cbLabView.ItemIndex:=i;
  EnableUpDown();
end;

procedure cbStateOnChange(sender:TObject);
begin
  LabChange(nil);
end;

procedure cbCountryOnChange(sender:TObject);
begin
  //podle vybraneho statu naplnime mozne kraje
  FillState();
  SerieChange(sender);
end;

procedure butFromGgOnClick(sender:TObject);  //nacte serii LABek z GeoGetu
var s,sSql,sId:string;
    g:TGeo;
    i,n,iPrvni,j,iMin,iMax:integer;
    sNameDivider:string;
    bChar:boolean;
begin
  GgForm_eIdTag.Text:='';
  sId:=Trim(GgForm_eId.Text);
  ClearTabGpx();
  if(sId='') then begin
    ShowMessage('Nen zadan GC kd rodiovsk kee/srie.');
    exit;
  end;
  //protoze to ma byt maska serie, doplnime na jeji konec '-', jestli tam neni
  if(Pos('-',sId)<=0) then sId:=sId+'-';
  //hledame masku serie (to ale muze dat i vice serii najednou
  sSql:='SELECT id FROM geocache WHERE id like "'+sId+'%" ORDER BY id';
  GEOGET_DB.GetTableStrings(sSql,GgForm_cbLabView.Items);
  s:=GgForm_cbLabView.Items.Text;
{$ifdef DEBUG_HELPER} LDH('SQL='+sSql+CRLF+'Seznam labek v serii: '+s); {$endif}
  iPrvni:=-1;
  GgForm_eId.Text:=Fetch(sId,'-');
  GgForm_cbLength.ItemIndex:=0;
  GgForm_cbNumbersOnly.ItemIndex:=1;
  n:=-1;
  bChar:=false;
  GgForm_eStartNum.Text:='0';   //predpokladame cislovani od 0
  GgForm_bSeq.Checked:=false;   //serie neni sekvencni
  GgForm_bBonus.Checked:=false; //a nema bonusovou kes (rodicovska <> bonusova)
  GgForm_bArchiv.Checked:=false;
  sNameDivider:='';
  for i:=0 to MAX_LAB do aLab[i].sName:='';
  g:=TGeo.Create();
  try
    while s<>'' do begin
      sId:=Fetch(s,CRLF);
      g.LoadByGc(sId);
{$ifdef DEBUG_HELPER} LDH('ID='+sId); {$endif}
      Fetch(sId,'-');
      i:=LabNum2Int(sId);
      if(iPrvni<0) then begin
        GgForm_eStartNum.Text:=IntToStr(i);
        iMin:=i;
        iMax:=i;
        //nastavime pocet znaku k cislovani
        if(iMin<10) and (Length(sId)>1) then GgForm_cbLength.ItemIndex:=1
        else GgForm_cbLength.ItemIndex:=0;
      end;
      if(i>iMax) then iMax:=i;
//{$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i)+', iPrvni='+IntToStr(iPrvni)+', iMin='+IntToStr(iMin)+', iMax='+IntToStr(iMax)); {$endif}
      i:=iMax-iMin;       //vypocteme index do pole
//{$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i)+', iPrvni='+IntToStr(iPrvni)+', iMin='+IntToStr(iMin)+', iMax='+IntToStr(iMax)); {$endif}
      if(i<0) or (i>MAX_LAB-1) then begin
        ShowMessage('Poradi LABky mimo rozsah: '+sId+CRLF+'Nen natena.');
        continue;
      end;
      GgForm_eNick.Text:=UtfToAnsi(g.Author);
//{$ifdef DEBUG_HELPER} LDH('g.Name='+g.Name); {$endif}
      aLab[i].sName:=UtfToAnsi(g.Name);
      if(sNameDivider<>'') then Fetch(aLab[i].sName,sNameDivider);
      j:=Round((StrToFloat(g.Difficulty)-1.)/0.5);
      aLab[i].iDiff:=j;
      j:=Round((StrToFloat(g.Terrain)-1.)/0.5);
      aLab[i].iTerr:=j;
      aLab[i].sCoord:=g.GetCoord();
      aLab[i].sLabIdOrd:=g.guid;
      aLab[i].sText:=UtfToAnsi(g.LongDescription);
//{$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i)+': '+aLab[i].sName+', '+
//        IntToStr(aLab[i].iDiff)+'/'+IntToStr(aLab[i].iTerr)+CRLF+'xxxxx LongDesc='+aLab[i].sText); {$endif}
      n:=n+1;
      if(iPrvni<0) then begin
        iPrvni:=i;
        aLab[i].sVideoId:='';
        aLab[i].sImgUrl:='';
        aLab[i].sMessageAward:='';
        aLab[i].sVideoIdAward:='';
        aLab[i].sImgUrlAward:='';
        aLab[i].sQuestion:='';
        GgForm_eOwnerId.Text:=g.OwnerId;
        GgForm_cbCountry.ItemIndex:=GgForm_cbCountry.Items.IndexOf(UtfToAnsi(g.Country));
        cbCountryOnChange(nil);
        GgForm_cbState.ItemIndex:=GgForm_cbState.Items.IndexOf(UtfToAnsi(g.State));
        cbStateOnChange(nil);
        //odstranime nami doplnene odkazy na LabId a bonusovou kesku
        if(Pos('<hr>',g.ShortDescription)>0) then begin //novy format s odkazy na zacatku
          GgForm_mText.Lines.Text:=RegexSubstitute('(?s)<hr>(.*)',UtfToAnsi(g.ShortDescription),'$1');
        end
        else GgForm_mText.Lines.Text:=UtfToAnsi(g.ShortDescription); //obsahuje jen cisty popis bez odkazu
        if(Pos('/',aLab[i].sName)>1) then sNameDivider:='/';
        if(Pos('-',aLab[i].sName)>1) and (sNameDivider='') then sNameDivider:='-';
        GgForm_eName.Text:=Fetch(aLab[i].sName,sNameDivider);
        GgForm_dtCreate.Date:=g.Hidden;
        //zjistime LabId
        GgForm_eIdTag.Text:=g.TagValues('LABid');
        AddGgInfo(GgForm_eIdTag.Text);  //a preneseme hodnoty z kese
      end;
    end;
  finally
    g.Free();
  end;
  GgForm_cbCount.ItemIndex:=n; //protoze n zacina s -1, je tu rovnou index poctu
  cbLabViewInit();
  iLab:=0;
  GgForm_cbLabView.ItemIndex:=iLab;
  //zakazeme zmenu poctu znaku a pocatek cislovani
  GgForm_eStartNum.Enabled:=false;
  GgForm_cbLength.Enabled:=false;
  if(bChar) then GgForm_cbNumbersOnly.ItemIndex:=1;
  GgForm_bGpx.Enabled:=true;
  EnableActions(nil);
  ShowLab(iLab);
  EnableUpDown();
  GgForm_eChangeGpx.Text:='';     //zadna zmena
  GgForm_bGGView.Checked:=true;   //jsou zobrazena data z GG
end;

procedure butFromGgSelOnClick(sender:TObject);  //nacte serii LABek z GeoGetu, GC kod vezme podle prvni vybrane kese
var s,s1,sFile:string;
    bod:TGeo;
begin
  sFile:=GetGpxDir()+'tmp.ggt';
  GeoListSave(sFile);
  s:=FileToString(sFile);
  DeleteFile(sFile);
  GgForm_eId.Text:='';
  //zjistime prvni vybranou kesku
  while((s<>'') and (GgForm_eId.Text='')) do begin
    bod:=TGeo.Create(); //pro vypnuti optimalizace musime vzdy vytvaret instanci znovu
    //bod.Gc(aList[i]);
    s1:=Fetch(s,CRLF);
    bod.id:=s1; // podle Gebyho staci jen priradit ID
    if(bod.IsSelected()) then GgForm_eId.Text:=bod.id;
    bod.Free();
  end;
  if(GgForm_eId.Text='') then begin
    ShowMessage('V GG seznamu neni vybrana zadna LAB');
    exit;
  end;
  s:=GgForm_eId.Text;
  GgForm_eId.Text:=Fetch(s,'-');
  if(s<>'') then begin  //pokud je to serie, ktera ma vice "casti", pridame znak serie
    if(s[1]>'9') then GgForm_eId.Text:=GgForm_eId.Text+'-'+s[1];
  end;
  butFromGgOnClick(nil);
end;

procedure butPropertiesOnClick(sender:TObject);  //nacte pouzitelne hodnoty z rodicovske kese
var g:TGeo;
    i:integer;
begin
  if(ParentCacheTest()=false) then exit;
  GgForm_eId.Text:=Trim(GgForm_eId.Text);
  if(GgForm_eId.Text='') then begin
    ShowMessage('Nen zadan GC kd rodiovsk kee.');
    exit;
  end;
  //eIdTag se nastavi nebo je nastaveno z API nebo pri nacteni z GG
  g:=TGeo.Create();
  try
    g.LoadByGc(GgForm_eId.Text);
    if(GgForm_eIdTag.Text='') then begin   //to ale muze byt jen po spusteni pluginu
      GgForm_eNick.Text:=UtfToAnsi(g.Author);
      GgForm_eOwnerId.Text:=g.OwnerID;
      aLab[i].sName:=UtfToAnsi(g.Name);
      GgForm_dtCreate.Date:=g.Hidden;
      GgForm_bSeq.Checked:=false;   //serie neni sekvencni
      GgForm_bBonus.Checked:=false; //a nema bonusovou kes (rodicovska <> bonusova)
      GgForm_bArchiv.Checked:=g.IsArchived();
      //pro jistotu povolime zmenu poctu znaku a pocatek cislovani
      GgForm_eStartNum.Enabled:=true;
      GgForm_cbLength.Enabled:=true;
    end;
    GgForm_cbCountry.ItemIndex:=GgForm_cbCountry.Items.IndexOf(UtfToAnsi(g.Country));
    cbCountryOnChange(nil);
    GgForm_cbState.ItemIndex:=GgForm_cbState.Items.IndexOf(UtfToAnsi(g.State));
    cbStateOnChange(nil);
    GgForm_bEvent.Checked:=IsEvent(g);
    GgForm_bGpx.enabled:=true;
  finally
    g.Free();
  end;
  EnableActions(nil);
end;

procedure butUploadOnClick(sender:TObject);
var sRes,sUrl,sFileName,sText:string;
begin
  //ShowMessage('Upload serie na web, soubor: '+GetLabFilename());
  sFileName:=RegExSubstitute('.*\\(.*)$',GetLabFilename(),'$1');
  //sestavime parametry
  sText:=//napred funkce
        '--#az09za90#'+CRLF
          +'Content-Disposition: form-data; name="f"'+CRLF+CRLF+'saveGpxFile'+CRLF
         //ted vlastni soubor
         +'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="fl"; filename="'+sFileName+'"'+CRLF
         +'Content-Type: application/octet-stream'+CRLF+CRLF
         +FileToString(GetLabFilename())+CRLF
         ;
  sText:=AddSender(sText)+'--#az09za90#'  //odesilatel, podle nej server pozna, ze jde o plugin a ne o formular
  //zkusime jak http (endora), tak https (provozni web)
  sUrl:=AddPassword(sWEBPUB_URL);
  {$ifdef DEBUG_HELPER} LDH('7. URL='+sUrl);{$endif}
  HttpAsk('POST',sUrl,'multipart/form-data; boundary=#az09za90#',sText,sRes);
  StringToFile(sRes,GetMyDir()+'HttpResponse.txt');
  if(sRes='') then sRes:=AnsiToUtf('ERR: odpov od serveru je przdn. Pravdpodobn nen sprvn zadan kombinace uivatel-heslo pro pstup k chrnn oblasti serveru.');
  //smazeme soubor se seznamem serii na serveru, aby se musel nacist znovu
  if(FileExists(GetServerSeriesPathname())) then DeleteFile(GetServerSeriesPathname());
  //pokud jsme na endora, smazeme s vysledku reklamu
  while(sRes<>'') do sText:=Fetch(sRes,'</div>');
  ShowMessage(UtfToAnsi(sText));
end;

procedure butSearchOnClick(sender:TObject);
var s,sGc,sId,sUrl,sParams,sRes,sDt:string;
    i:integer;
begin
  //sestavime POST pozadavek
  GgForm_butSearch.Cursor:=crHourglass;
  sParams:='';
  GgForm_sZobrazeno.Caption:='Zobrazeno: ???';
  if(GgForm_eSearchId.Text<>'') then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="id"'+CRLF+CRLF
         +GgForm_eSearchId.Text+CRLF;
  if(GgForm_eSearchName.Text<>'') then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="name"'+CRLF+CRLF
         +GgForm_eSearchName.Text+CRLF;
  if(GgForm_eSearchAuthor.Text<>'') then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="author"'+CRLF+CRLF
         +GgForm_eSearchAuthor.Text+CRLF;
  if(GgForm_eSearchCountry.Text<>'') then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="country"'+CRLF+CRLF
         +GgForm_eSearchCountry.Text+CRLF;
  if(GgForm_eSearchState.Text<>'') then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="state"'+CRLF+CRLF
         +GgForm_eSearchState.Text+CRLF;
  if(GgForm_rSearchBonus.ItemIndex<>2) then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="bonus"'+CRLF+CRLF
         +IntToStr(GgForm_rSearchBonus.ItemIndex)+CRLF;
  if(GgForm_rSearchSeq.ItemIndex<>2) then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="seq"'+CRLF+CRLF
         +IntToStr(GgForm_rSearchSeq.ItemIndex)+CRLF;
  if(GgForm_rSearchEvent.ItemIndex<>2) then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="event"'+CRLF+CRLF
         +IntToStr(GgForm_rSearchEvent.ItemIndex)+CRLF;
  if(GgForm_rSearchArchiv.ItemIndex<>2) then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="archiv"'+CRLF+CRLF
         +IntToStr(GgForm_rSearchArchiv.ItemIndex)+CRLF;
  if(GgForm_eSearchAutorGpx.Text<>'') then sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="authorGpx"'+CRLF+CRLF
         +GgForm_eSearchAutorGpx.Text+CRLF;
  sDt:=FormatDateTime('yyyy"-"mm"-"dd" ',GgForm_dtSearchDate.Date)+
       FormatDateTime('hh":"nn',GgForm_dtSearchTime.Time);
//{$ifdef DEBUG_HELPER} LDH('Datum publikace serie: '+sDt);{$endif}
  if(GgForm_rSearchPub.ItemIndex<>2) then begin
         sParams:=sParams+'--#az09za90#'+CRLF
         +'Content-Disposition: form-data; name="dt"'+CRLF+CRLF
         +IntToStr(GgForm_rSearchPub.ItemIndex)+CRLF
         +'--#az09za90#'+CRLF+'Content-Disposition: form-data; name="dtText"'+CRLF+CRLF
         +sDt+CRLF;
  end;
  sUrl:=sWEB_URL;
    sParams:=sParams+'--#az09za90#'+CRLF
      +'Content-Disposition: form-data; name="f"'+CRLF+CRLF+'search'+CRLF;
  //pridame identifikaci pluginu a ukoncime parametry
  sParams:=AddSender(sParams)+'--#az09za90#';
  {$ifdef DEBUG_HELPER} LDH('1. sUrl='+sUrl);{$endif}
  HttpAsk('POST',sUrl,'multipart/form-data; boundary=#az09za90#',AnsiToUtf(sParams),sRes);
  StringToFile(sRes,GetMyDir()+'HttpSearchResponse.txt');
  GgForm_lSearch.Items.Text:=UtfToAnsi(sRes);
  //pokud je pozadovano, vyhazeme kese, ktere uz v databazi jsou
  if(GgForm_bSearchMissing.Checked) then begin
    for i:=GgForm_lSearch.Items.Count-1 downto 0 do begin
      s:=GgForm_lSearch.Items[i];
      sGc:=Fetch(s,'|'); Fetch(s,'|'); Fetch(s,'|'); Fetch(s,'|'); Fetch(s,'|');
      //s:=GEOGET_DB.GetTableString('SELECT id FROM geocache WHERE id LIKE "'+sId+'-%"');
      sId:=Fetch(s,'|');
      s:=GcFromLabId(sId); //seznam GC kodu s timto ID, ktere mame v databazi
      if(s<>'') then GgForm_lSearch.Items.Delete(i);
    end;
  end;
  GgForm_sZobrazeno.Caption:='Zobrazeno: '+IntToStr(GgForm_lSearch.Items.Count)+' sri';
  GgForm_butSearchDownload.Enabled:=(GgForm_lSearch.Items.Count>0);
  GgForm_butSearch.Cursor:=crDefault;
end;

procedure butReliktDelOnClick(sender:TObject);
var sRes,sParams,sUrl:string;
begin
  sUrl:=AddPassword(sWEBPUB_URL);
  //{$ifdef DEBUG_HELPER} LDH('sUrl='+sUrl);{$endif}
  sParams:='--#az09za90#'+CRLF
      +'Content-Disposition: form-data; name="f"'+CRLF+CRLF+'delReliktFiles'+CRLF
      +AddSender(sParams)+'--#az09za90#';
  HttpAsk('POST',sUrl,'multipart/form-data; boundary=#az09za90#',sParams,sRes);
  ShowMessage(sRes);
end;

procedure butGgOnlyOnClick(sender:TObject);
var s,sId,sRes,sParams,sUrl,sSql,sFile:string;
    i:integer;
    aList:TStringList;
begin
  GgForm_butGgOnly.Cursor:=crHourglass;
  aList:=TStringList.Create();
  try
    sUrl:=sWEB_URL;
    sParams:='--#az09za90#'+CRLF
        +'Content-Disposition: form-data; name="f"'+CRLF+CRLF+'search'+CRLF
        +AddSender(sParams)+'--#az09za90#';
    HttpAsk('POST',sUrl,'multipart/form-data; boundary=#az09za90#',sParams,sRes);
    StringToFile(sRes,GetMyDir()+'HttpSearchResponse.txt');
    aList.Text:=UtfToAnsi(sRes);
    {$ifdef DEBUG_HELPER} LDH('Pocet ziskanych LAB z webu: '+IntToStr(aList.Count));{$endif}
    for i:=aList.Count-1 downto 0 do begin
      s:=aList[i];
      aList[i]:=Fetch(s,'|');
    end;
    sRes:=aList.Text+CRLF;
    aList.Text:='';
    sSql:='SELECT id FROM geocache WHERE cachetype="Lab Cache" ORDER BY id';
    GEOGET_DB.GetTableStrings(sSql,aList);
    {$ifdef DEBUG_HELPER} LDH('Pocet ziskanych LAB z GG: '+IntToStr(aList.Count));{$endif}
    for i:=aList.Count-1 downto 0 do begin
      s:=aList[i];
      sId:=Fetch(s,'-');
      if(Pos(sId+CRLF,sRes)>=1) then aList.Delete(i);
    end;
    {$ifdef DEBUG_HELPER} LDH('Zbyly pocet v GG: '+IntToStr(aList.Count));{$endif}
    sFile:=GetMyDir()+'LabsGgOnly.ggt'
    StringToFile(aList.Text,sFile);
    GeoListClear();
    GeoListFileAdd(sFile);
    DeleteFile(sFile);
    ShowMessage('V okne GeoGetu je '+IntToStr(aList.Count)+' LAB kesi, ktere nejsou na webu.');
  finally
    aList.Free();
  end;
  GgForm_butGgOnly.Cursor:=crDefault;
end;

procedure bSearchImportOnClick(sender:TObject);
begin
  GgForm_bSearchSaveTime.Enabled:=(GgForm_bSearchImport.Checked);
end;

procedure butSearchDownloadOnClick(sender:TObject);
var i,n:integer;
    s,sGc,sId,sIds,sName:string;
begin
  n:=0; //zadny stazeny soubor
  DelTree(GetGpxDir());           //vymazat pracovni adresar
  GeoBusyStart();
  GeoBusyCaption('Download GPX soubor...');
  ForceDirectories(GetGpxDir());
  for i:=0 to GgForm_lSearch.Items.Count-1 do begin
    if(GgForm_lSearch.Selected[i]=false) then continue;
    //sestavime POST pozadavek na stazeni souboru
    s:=GgForm_lSearch.Items[i];
{$ifdef DEBUG_HELPER} LDH('radek: '+s); {$endif}
    sGc:=Fetch(s,'|');
    sName:=Fetch(s,'|'); Fetch(s,'|'); Fetch(s,'|'); Fetch(s,'|');
    sId:=Fetch(s,'|');
    sIds:=sIds+sId+CRLF;
  end;
  sIds:=ReplaceString(Trim(sIds),CRLF,','); //seznam vsech LabId
{$ifdef DEBUG_HELPER} LDH('seznam pozadovanych LabId: '+sIds); {$endif}
  if(sIds='') then ShowMessage('Nen oznaena dn srie ke staen.')
  else DownloadAndImportList(sIds,GgForm_bSearchImport.Checked); //stahnem a pokud je treba, tak i importujeme
  if(GgForm_bSearchSaveTime.Checked) and (GgForm_bSearchImport.Checked) then SaveImportTime();

end;

procedure cbServerOnChange(sender:TObject);
begin
  sWEB_URL:=WEB_URL; sWEBPUB_URL:=WEBPUB_URL; sWEBPUB_USER:=WEBPUB_USER; sWEBPUB_PWD:=WEBPUB_PWD;
  if(GgForm_cbServer.ItemIndex=1) then begin
    sWEB_URL:=WEB_URL2; sWEBPUB_URL:=WEBPUB_URL2; sWEBPUB_USER:=WEBPUB_USER2; sWEBPUB_PWD:=WEBPUB_PWD2;
  end
end;

procedure cbProfileOnChange(sender:TObject);
begin
  ProfileRead(GgForm_CbProfile.Items[GgForm_CbProfile.ItemIndex]);//ulozime aktualni profil
end;

procedure butProfileSaveOnClick(sender:TObject);
begin
  ProfileSave(GgForm_CbProfile.Items[GgForm_CbProfile.ItemIndex]);//ulozime aktualni profil
end;

procedure butProfileSaveAsOnClick(sender:TObject);
var sName:string;
begin
  sName:=InputBox('Jmno novho profilu','Nov jmno:',''); //zeptame se na jmeno profilu a ulozime ho
  if(sName='') then exit;
  ProfileSave(sName);
  if(GgForm_cbProfile.Items.IndexOf(sName)<0) then GgForm_cbProfile.Items.Add(sName);
  GgForm_cbProfile.ItemIndex:=GgForm_cbProfile.Items.IndexOf(sName);
  cbProfileOnChange(nil);
end;

procedure eStartNumOnChange(sender:TObject);
var str:string;
    i:integer;
begin
  str:=GgForm_eStartNum.Text;
  if(str='') then str:='0';
  i:=StrToInt(str);
  GgForm_sStartNum.Caption:='('+Int2Labnum(i)+')';
  if(i>1295) then ShowMessage('slo je pli velik, maximum je 1295.');
  AddChangeType('NUM');
  SerieChange(nil);
end;

procedure cbNumOnChange(sender:TObject);
begin
  AddChangeType('NUM');
  SerieChange(nil);
end;

procedure butNumConvertOnClick(sender:TObject);
var str:string;
    i:integer;
begin
  str:='';
  while(true) do begin
    str:=InputBox('Pevod kdu na slo','Zadejte kd 0-ZZ:',str);
    if(str='') then exit;
    if(length(str)>2) then begin
      ShowMessage('Lze pout nejve dvojznakov kd!');
      continue;
    end;
    i:=Labnum2Int(str);
    GgForm_eStartNum.Text:=IntToStr(i);
    GgForm_sStartNum.Caption:='('+UpperCase(str)+')';
    exit;
  end;
end;

procedure lSearchOnKeyDown(sender:TObject;var Key: Word; Shift: TShiftState);
var i:integer;
begin
  //if(sender=GgForm_lSearch) and (GgForm_lSearch.MultiSelect=true) then begin
    //CTRL+A oznaci vsechny polozky
    if((Key=65) and (Shift=[ssCtrl])) then begin
      for i:=0 to GgForm_lSearch.Items.Count-1 do begin
        GgForm_lSearch.Selected[i]:=true;
      end;
      Key:=0; //priznak zpracovaneho tlacitka
    end;
  //end;
end;

procedure butApiCoordOnClick(sender:TObject);
var s:string;
    x,y:extended;
    b:boolean;
    g:TGeo;
begin
  s:=Trim(GgForm_eApiCoord.Text); //stavajici souradnice
{$ifdef DEBUG_HELPER} LDH('coord='+s); {$endif}
  if(s='') then begin
    //pokud je zadana rodicovska keska, pouzijeme jeji souradnice
    if(GgForm_eId.Text<>'') then begin
      {$ifdef DEBUG_HELPER} LDH('GC='+GgForm_eId.Text); {$endif}
      g:=TGeo.Create();
      try
        g.LoadByGc(GgForm_eId.Text);
        s:=g.GetCoord();
        {$ifdef DEBUG_HELPER} LDH('coord='+s); {$endif}
      finally
        g.Free();
      end;
    end else s:='5001.000; 1426.000'; //aby tam nejake byly
  end;
  ParseWgsStr(s,x,y);           //parsujeme
  //{$ifdef DEBUG_HELPER} LDH('1 x='+FloatToStr(x)+', y='+FloatToStr(y)); {$endif}
  b:=CoordEdit('Souradnice LABky','',x,y);
  //{$ifdef DEBUG_HELPER} LDH('2 x='+FloatToStr(x)+', y='+FloatToStr(y)); {$endif}
  if(b) then begin
    GgForm_eApiCoord.Text:=FormatCoordNum(x,y);
  end;
end;

procedure ApiSearch(sender:TObject;sLat,sLon,sRadius:string);
var sUrl,sRes,s,sList,sListParse:string;
    Xml:TJclSimpleXML;
    elem,eItems: TJclSimpleXMLElem;
    b:boolean;
    idxItems,i:integer;
    aList:TStringList;
begin
  if(GgForm_eApiCoord.Text='') and (GgForm_rApiShow.ItemIndex<>3) then begin
    ShowMessage('Nejsou zadane souradnice stredu.');
    exit;
  end;
  if(sender<>nil) then (sender as TButton).Cursor:=crHourglass;
  aList:=TStringList.Create();
  try
    //kvuli CR vice kruznicim nastavime ignorovani duplicit
    aList.Duplicates:=dupIgnore;
    aList.Sorted:=true;
    if(iApiSearchIndex>1) then aList.Text:=GgForm_lApiSerie.Items.Text;
    if(GgForm_rApiShow.ItemIndex=2) then begin
      if(AgeOfFile(GetServerSeriesPathname())>1440) then
        sList:=GetSeriesFromServer()  //nacteme seznam ze serveru
        else sList:=FileToString(GetServerSeriesPathname());
    end;
    //zavolame URL a nacteme seznam
    sUrl:='https://labs-api.geocaching.com/Api/Adventures/SearchV3?radiusMeters='
      +sRadius+'&origin.latitude='+sLat+'&origin.longitude='+sLon;
    {$ifdef DEBUG_HELPER} LDH('2. URL='+sUrl); {$endif}
    HttpAsk('GET',sUrl,'','',sRes);
    {$ifdef DEBUG_HELPER} LDH('... URL nacteno'); {$endif}
    //StringToFile(sRes,GetMyDir()+'ApiRadius.txt');
    //parsujeme ziskane xml
    Xml:=TJclSimpleXml.Create();
    try
      //### kvuli nacitani nekterych jmen je treba predavat UTF a ne ANSI
      //### a je pak potreba prevadet jednotlive polozky z parseru
      Xml.LoadFromString({UtfToAnsi}(sRes));
      b:=false;
      for idxItems:=0 to XML.Root.Items.count-1 do begin //hledame polozku Items
        if(XML.Root.Items[idxItems].name='Items') then begin b:=true; break; end;
      end;
      if(b=false) then begin
        s:=GetMyDir()+'\ERR_ApiResult.txt';
        ShowMessage('ERR: chyba parsovani XML dat pro kruh:'+CRLF
            +'Kruh: '+sLat+', '+sLon+', r='+sRadius+CRLF+CRLF
            +'nenalezeno <Items>, soubor ulozen do '
          +s);
        StringToFile(sRes,s);
      end
      else begin
        eItems:=XML.Root.Items[idxItems];
        if(eItems.Items.count>450) then
          ShowMessage('WARN: pocet serii v kruhu je '+IntToStr(eItems.Items.count)+CRLF
            +'Kruh: '+sLat+', '+sLon+', r='+sRadius+CRLF+CRLF
            +'To je vic nez 450 a nebezpecne se blizi k maximalnimu poctu 500 najednou vracenych serii z API.');
        for i:=0 to eItems.Items.count-1 do begin
          elem:=eItems.Items[i];
    {$ifdef DEBUG_HELPER} LDH('elem[i]='+elem.name); {$endif}
          s:=UtFToAnsi(elem.items.Itemnamed['Title'].Value)+'  |  '+UtFToAnsi(elem.items.Itemnamed['Id'].Value);
          sListParse:=sListParse+s+CRLF;
          case GgForm_rApiShow.ItemIndex of
          0:;
          1: //pokud uz je v databazi, vynechame ji
             if(GcFromLabId(elem.items.Itemnamed['Id'].Value)<>'') then continue;
          2: begin
               {$ifdef DEBUG_HELPER} LDH('Hledam Id='+elem.items.Itemnamed['Id'].Value);{$endif}
               if(Pos(elem.items.Itemnamed['Id'].Value,sList)>0) then continue;
             end;
          end;
          aList.Add(s);
          GgForm_lApiSerie.Items.Add(s);
        end;
        if(FileExists(GetApiRadiusParsePathname())) then begin
          if(iApiSearchIndex>1) then sListParse:=FileToString(GetApiRadiusParsePathname())+sListParse;
        end;
        StringToFile(sListParse,GetApiRadiusParsePathname());
      end;
    finally
      Xml.Free();
    end;
    GgForm_lApiSerie.Items.Text:=aList.Text;
  finally
    aList.Free();
  end;
  if(sender<>nil) then (sender as TButton).Cursor:=crDefault;
end;

procedure butApiSearchOnClick(sender:TObject);
var s,sSec,sUrl:string;
    ini:TMemIniFile;
    aList:TStringList;
    sLat,sLon:string;
    x,y:extended;
    i:integer;
begin
  GgForm_lApiSerie.Items.Text:='';
  {$ifdef DEBUG_HELPER} LDH('X. GgForm_cbApiRegions.ItemIndex='+IntToStr(GgForm_cbApiRegions.ItemIndex)); {$endif}
  case GgForm_cbApiRegions.ItemIndex of
  0:  begin     //zadane souradnice a polomer
      //pokud je soubor se seznamem na serveru starsi nez 1 den, stahneme novy
      //N504.276' E01429.587' (Gutovka)
      //N4954.307' E0148.903' (Liten)
      ParseWgsStr(GgForm_eApiCoord.Text,x,y);           //parsujeme
      sLat:=FloatToStr(x);
      sLon:=FloatToStr(y);
      iApiSearchIndex:=0;
      ApiSearch(sender,sLat,sLon,GgForm_eApiRadius.Text);
      end;
  1:  begin    //zadane LabId
        GgForm_lApiSerie.Items.Text:='??? (N=jmno nezjisteno) | '+GGForm_eApiLabId.Text;
      end;
  2:  begin    //zadany SmartLink
        //pokud je misto slova zadane cele URL, separujeme jen slovo a vyhodime
        //pripadne uvozovky, pokud by jimi bylo obalene
        if(Pos('http',GGForm_eApiSmartLink.Text)>=0) then
          GGForm_eApiSmartLink.Text:=ReplaceString(RegexReplace('.*\/', GGForm_eApiSmartLink.Text,'',false),'"','');
        sUrl:='https://labs-api.geocaching.com/Api/Adventures/GetAdventureIdBySmartLink';
        //{$ifdef DEBUG_HELPER} LDH('X. URL='+sUrl); {$endif}
        HttpAsk('POST',sUrl,'application/json','"'+GGForm_eApiSmartLink.Text+'"',s);
        {$ifdef DEBUG_HELPER} LDH('X. odpoved='+s); {$endif}
        Fetch(s,'>');
        {$ifdef DEBUG_HELPER} LDH('... URL nacteno'); {$endif}
        GgForm_lApiSerie.Items.Text:='??? (N=jmno nezjisteno) | '+Fetch(s,'<');
      end;
  else begin  //oblasti jsou zadane v INI a je jich vice
        //nacteme postupne vsechny regiony z INI a pro kazdy vyhledame labky
        ini:=TMemIniFile.Create(GetMyDir()+'ApiRegions.ini');
        try
          sSec:=GgForm_cbApiRegions.Items[GgForm_cbApiRegions.ItemIndex];
          aList:=TStringList.Create();
          try
            ini.ReadSectionValues(sSec,aList{,[svoIncludeInvalid]});
            for i:=0 to aList.Count-1 do begin
              s:=aList[i];
              Fetch(s,'=');
              sLat:=Fetch(s,' ');
              sLon:=Fetch(s,' ');
              if(s='') then begin
                ShowMessage('ERR: chybna definice kruhu c. '+IntToStr(i+1)+CRLF+CRLF
                  +'Definice neobsahuje 3 polozky (Lat, Lon, polomer) oddelene mezerou!');
                continue;
              end;
              iApiSearchIndex:=i+1;
              ApiSearch(sender,sLat,sLon,s);
            end;
          finally
            aList.Free();
          end;
        finally
          ini.Free();
        end;
      end;
  end;
  GgForm_sApiCount.Caption:='('+IntToStr(GgForm_lApiSerie.Items.Count)+')';
  iApiSearchIndex:=0;
end;

procedure butCountInCirclesOnClick(sender:TObject);
var s,sSec,sUrl,sRes,sOut:string;
    ini:TMemIniFile;
    aList:TStringList;
    sLat,sLon:string;
    i:integer;
begin
  //nacteme postupne vsechny regiony z INI a pro kazdy vyhledame labky
  GeoBusyStart();
  GeoBusyCaption('Zjisteni obsazenosti kruh');
  ini:=TMemIniFile.Create(GetMyDir()+'ApiRegions.ini');
  try
    sSec:=GgForm_cbApiRegions.Items[GgForm_cbApiRegions.ItemIndex];
    aList:=TStringList.Create();
    try
      ini.ReadSectionValues(sSec,aList{,[svoIncludeInvalid]});
      for i:=0 to aList.Count-1 do begin
        s:=aList[i];
        GeoBusyKind(s);
        GeoBusyProgress(i+1,aList.Count);
        s:=ReplaceString(s,',',' '); //carku nahradime mezerou, kdyby tam byl oddelovac carka
        sOut:=sOut+CRLF+s;
        Fetch(s,'=');
        sLat:=Fetch(s,' ');
        sLon:=Fetch(s,' ');
        if(s='') then begin
          ShowMessage('ERR: chybna definice kruhu c. '+IntToStr(i+1)+CRLF+CRLF
            +'Definice neobsahuje 3 polozky (Lat, Lon, polomer) oddelene mezerou!');
          continue;
        end;
        //zavolame URL a nacteme seznam
        sUrl:='https://labs-api.geocaching.com/Api/Adventures/SearchV3?radiusMeters='
          +s+'&origin.latitude='+sLat+'&origin.longitude='+sLon;
        {$ifdef DEBUG_HELPER} LDH('... URL='+sUrl); {$endif}
        HttpAsk('GET',sUrl,'','',sRes);
        {$ifdef DEBUG_HELPER} LDH('... URL nacteno pro Reg'+intToStr(i+1)); {$endif}
        Fetch(sRes,'<TotalCount>');
        sOut:=sOut+': '+Fetch(sRes,'<');
        StringToFile(sRes,GetMyDir()+'ApiRadius.txt');
        //break;
      end;
    finally
      aList.Free();
    end;
  finally
    ini.Free();
  end;
  StringToFile(sOut,GetMyDir()+'Obsazenost.txt');
  ShowMessage(sOut+CRLF+CRLF+'... totez je v souboru Obsazenost.txt');
end;

procedure CheckName; //zkontroluje jmeno serie z API, zda odpovida jmenu serie z GG
var s:string;
begin
  GgForm_butNameApiCopyRed.Hint:=GgForm_eNameApi.Text;
  GgForm_butNameApiCopy.Hint:=GgForm_eNameApi.Text;
  GgForm_butNameApiCopyRed.Visible:=false;
  GgForm_butNameApiCopy.Visible:=true;
  GgForm_butNameApiCopy.Enabled:=true;

  if(GgForm_eName.Text='') then exit; //neni co kontrolovat
  if(GgForm_eName.Text=GgForm_eNameApi.Text) then exit; //jmena jsou shodna
  s:=ReplaceString(GgForm_eNameApi.Text,' / ',' (')+')';
  if(UpperCase(GgForm_eName.Text)=UpperCase(s)) then exit; //upravene jmeno je shodne
  s:=ReplaceString(GgForm_eNameApi.Text,'/','-');
  if(UpperCase(GgForm_eName.Text)=UpperCase(s)) then exit; //upravene jmeno je shodne
  GgForm_butNameApiCopyRed.Visible:=true;
  GgForm_butNameApiCopy.Visible:=false;
  ShowMessage('WARN: Jmeno v GG a jmeno z API si neodpovidaji!'+CRLF+CRLF
    +GgForm_eName.Text+CRLF+GgForm_eNameApi.Text);
end;

procedure butApiUseOnClick(sender:TObject);
var s,sId:string;
begin
  if((sender as TBUTTON)=GgForm_butApiUse) then begin
    ClearTabGpx(); //vymazeme formular jen pri teto funkci, pri "modre sipce" tam zustanou informace z GG
    if(GgForm_lApiSerie.ItemIndex<0) then begin
      ShowMessage('Neni vybrana zadna serie.');
      exit;
    end;
    (sender as TBUTTON).Cursor:=crHourglass;
    s:=GgForm_lApiSerie.Items[GgForm_lApiSerie.ItemIndex];
    Fetch(s,'|'); //nechame jen ID
  end;
  if((sender as TBUTTON)=GgForm_butFromLabId) then begin
    if(GgForm_eIdTag.Text='') then begin
      ShowMessage('Neni zadane LabId serie.');
      exit;
    end;
    (sender as TBUTTON).Cursor:=crHourglass;
    s:=GgForm_eIdTag.Text;
  end;
  sId:=s;
  GetBasicInfo(sId,''); //zakladni info o cele serii
  GetLabsInfo(sId,'');  //detaily o jednotlivych LABkach
  CheckName();
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crDefault;
  GgForm_pTabs.ActivePage:=GGForm_tabGpx;
end;

procedure rApiShowOnClick(sender:TObject);
var sName,sGc,sId,sRes,sList:string;
begin
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crHourglass;
  //{$ifdef DEBUG_HELPER} LDH('rApiShowOnClick()');{$endif}
  //tohle preskocit nemuzu, pouzije se posledni nactene hodoty
  //if(GgForm_lApiSerie.Items.Text='') then exit;
  GgForm_lApiSerie.Items.Text:='';
  //pokud je potreba, nacteme soubor ze serveru
  //{$ifdef DEBUG_HELPER} LDH('Stari souboru '+GetServerSeriesPathname()
  //  +': '+IntToStr(AgeOfFile(GetServerSeriesPathname())));{$endif}
  if(GgForm_rApiShow.ItemIndex=2) then begin
    //if(AgeOfFile(GetServerSeriesPathname())>1440) then
      sList:=GetSeriesFromServer();  //nacteme seznam ze serveru
    //else sList:=FileToString(GetServerSeriesPathname());
  end;
  if(not FileExists(GetApiRadiusParsePathname())) then sRes:=''
  else sRes:=FileToString(GetApiRadiusParsePathname());
  while(sRes<>'') do begin
    sId:=Trim(Fetch(sRes,chr($0A){CRLF}));
    //{$ifdef DEBUG_HELPER} LDH('1. sId='+sId);{$endif}
    sName:=Fetch(sId,'|');
    //{$ifdef DEBUG_HELPER} LDH('2. sId='+sId);{$endif}
    case GgForm_rApiShow.ItemIndex of
    0: ;
    1: begin//jen ty, ktere nejsou v databazi
         sGc:=GcFromLabId(sId);
         if(sGc<>'') then continue; //tato serie uz je v GG
       end;
    2: begin
         {$ifdef DEBUG_HELPER} LDH('Hledam Id='+sId);{$endif}
         if(Pos(sId,sList)>0) then continue;
       end;
    end;
    GgForm_lApiSerie.Items.Add(sName+' | '+sId);
  end;
  GgForm_sApiCount.Caption:='('+IntToStr(GgForm_lApiSerie.Items.Count)+')';
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crDefault;
end;

procedure butIdCopyOnClick(sender:TObject);
begin
  ClipboardWriteText(GgForm_eIdTag.Text);
  ShowMessage('LabId zkoprovno do schrnky.');
end;

procedure butQrCopyOnClick(sender:TObject);
begin
  ClipboardWriteText(GgForm_eUrlQr.Text);
  ShowMessage('URL zkoprovno do schrnky.');
end;

procedure butCoordCopyOnClick(sender:TObject);
begin
  ClipboardWriteText(GgForm_eCoord.Text);
  ShowMessage('Souadnice zkoprovny do schrnky.');
end;

procedure butIdTagEditOnClick(sender:TObject);
begin
  GgForm_eIdTag.Enabled:=not GgForm_eIdTag.Enabled;
end;

procedure butQrEditOnClick(sender:TObject);
begin
  GgForm_eUrlQr.Enabled:=not GgForm_eUrlQr.Enabled;
end;

procedure butQrGoToOnClick(sender:TObject);
begin
  butFceOtherOnClick(nil);
  if(GgForm_eUrlQr.Text<>'') then RunShell(GgForm_eUrlQr.Text);
end;

procedure butCompareOnClick(sender:TObject);
var s,s1,s2:string;
begin
  butFceOtherOnClick(nil);
  if(GgForm_eIdTag.Text='') then exit;
  //nechame jen server
  s1:=sWEBPUB_URL;
  s:=Fetch(s1,'//')+'//';
  while(s1<>'') do begin
    s2:=Fetch(s1,'/')+'/';
    if(s2<>'Admin/') then s:=s+s2
    else break;
  end;
  s:=s+'checkSeries.php?LabId='+GgForm_eIdTag.Text;
  RunShell(s);
end;

procedure butLabVideoOnClick(sender:TObject);
begin
  if(GgForm_cbLabView.ItemIndex<0) then exit;
  if((sender as TButton)=GgForm_butLabVideo) then
    RunShell('https://www.youtube.com/watch?v='+aLab[GgForm_cbLabView.ItemIndex].sVideoId);
  if((sender as TButton)=GgForm_butLabVideoAward) then
    RunShell('https://www.youtube.com/watch?v='+aLab[GgForm_cbLabView.ItemIndex].sVideoIdAward);
end;

procedure butLabPictureOnClick(sender:TObject);
var s,sPrip:string;
begin
  if(GgForm_cbLabView.ItemIndex<0) then exit;
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crHourGlass;
  if((sender as TButton)=GgForm_butLabPicture) then HttpAsk('GET',aLab[GgForm_cbLabView.ItemIndex].sImgUrl,'','',s);
  if((sender as TButton)=GgForm_butLabPictureAward) then begin
    HttpAsk('GET',aLab[GgForm_cbLabView.ItemIndex].sImgUrlAward,'','',s);
    sPrip:='_Award';
  end;
  StringToFile(s,GetGpxDir()+'\Img_'+IntToStr(GgForm_cbLabView.ItemIndex+1)+sPrip+'.jpg');
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crDefault;
  if(s='') then ShowMessage('Nepodarilo se obrazek nacist.')
  else RunShell(GetGpxDir()+'\Img_'+IntToStr(GgForm_cbLabView.ItemIndex+1)+sPrip+'.jpg');
end;

procedure butLabQuestionOnClick(sender:TObject);
begin
  if(GgForm_cbLabView.ItemIndex<0) then exit;
  ShowMessage(aLab[GgForm_cbLabView.ItemIndex].sQuestion);
end;

procedure butShowXmlOnClick(sender:TObject);
begin
  butFceOtherOnClick(nil);
  if(GgForm_eIdTag.Text='') then exit;
  RunShell('https://labs-api.geocaching.com/Api/Adventures/'+GgForm_eIdTag.Text);
end;

procedure butShowXmlBasicOnClick(sender:TObject);
begin
  butFceOtherOnClick(nil);
  if(GgForm_eIdTag.Text='') then exit;
  RunShell('https://labs-api.geocaching.com/Api/Adventures/GetAdventureBasicInfo?Id='+GgForm_eIdTag.Text);
end;

procedure butLabMapyczOnClick(sender:TObject);
var sUrl,sX,sY:string;
    x,y:extended;
begin
  if(GgForm_eLabCoord.Text='') then exit;
  ParseWgsStr(GgForm_eLabCoord.Text,x,y);
  sX:=FloatToStr(x);
  sY:=FloatToStr(y);
  sUrl:='https://mapy.cz/turisticka?x='+sY+'&y='+sX+'&z=16&source=coor&id='+sY+'%2C+'+sX;
  RunShell(sUrl);
end;

procedure butLabOsmOnClick(sender:TObject);
var sUrl,sX,sY:string;
    x,y:extended;
begin
  if(GgForm_eLabCoord.Text='') then exit;
  ParseWgsStr(GgForm_eLabCoord.Text,x,y);
  sX:=FloatToStr(x);
  sY:=FloatToStr(y);
  sUrl:='https://openstreetmap.cz/#map=18/'+sX+'/'+sY+'&layers=mAKCGB';
  BrowseURL(sUrl);
  //RunShell(sUrl);
end;

procedure butFromOfflineOnClick(sender:TObject);
var s,sFile{,sDir,sLabId,sId}:string;
begin
  ClearTabGpx();
  if(not OpenDlg('XML soubor se sri LABek', GetMyDir()+'Offline', '', 'XML soubor (*.xml)|*.xml',sFile)) then exit;
  s:=FileToString(sFile);  //nacteme soubor

  if(Pos('AdventureBasicInfoModel',s)>0) then GetBasicInfo('',s)
  else GetLabsInfo('',s);
  {
  sDir:=RegexSubstitute('(.*\\).*',sFile,'$1');
  sFile:=ReplaceString(sFile,sDir,'');
  //pokud bylo ulozeno is s GC kodem separujeme jej
  if(sFile[0]='G') and (sFile[1]='C') then sId:=Fetch(sFile,'_');
  sLabId:=Fetch(sFile,'.');
  }
end;

procedure butLabMessageOnClick(sender:TObject);
begin
  ShowMessage(aLab[GgForm_cbLabView.ItemIndex].sMessageAward);
end;

procedure butLabOrderOnClick(sender:TObject);
var sHtml,s,sCss:string;
    i:integer;
begin
  //zobrazime prehled o kontrole poradi labek
  sHtml:='<table style="border-collapse:collapse; text-align:center; margin-top:5px;"'
    +' border="2" align="center" width="400">'
    +'<tr style="background-color:#DDDDDD;"><th>V GeoGetu</th><th>V API</th><th>Ureno</th><th>Jmno v GeoGetu<br>Jmno z API</th></tr>'+CRLF;
  for i:=0 to rCmpOld.nCount-1 do begin
    sCss:='';
    s:=PrintCmpIType(rCmpOld.Items[i].iCmpType);
    if(s='-!!!-') then begin
      s:='1. voln';
      sCss:='background-color:#FFFF99;';
    end;
    if(s='neureno') then begin
      s:='1. voln';
      sCss:='background-color:#FF0000; color:#FFCC00;';
    end;
    sHtml:=sHtml+'<tr style="'+sCss+'"><td>'+IntToStr(i)+'</td><td>'+IntToStr(rCmpOld.Items[i].idx)+'</td>'
      +'<td>'+s+'</td><td>'+aLabOld[i].sName+'<br>'+aLab[rCmpOld.Items[i].idx].sName+'</td></tr>'+CRLF;
  end;
  sHtml:=sHtml+'</table>';
  ShowHTMLMessageSize('Zjitn poad LABek', sHtml,455,300);
end;

procedure butLabsSaveOnClick(sender:TObject);
var s,sDir,sFile,sText,sImg:string;
    i:integer;
begin
  if(GgForm_eId.Text='') then begin
    ShowMessage('Je teba zadat GC kd rodiovsk kee. Od nj budou odvozena jmna soubor.');
    exit;
  end;
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crHourGlass;
  sDir:=GetMyDir()+'SaveFiles\'+GgForm_eId.Text;
  ForceDirectories(sDir);
  sText:=GgForm_eName.Text+CRLF
    +'==============================================='+CRLF
    +'Popis:'+CRLF
    +'------'+CRLF
    +GgForm_mText.Lines.Text+CRLF+CRLF;
  for i:=0 to GgForm_cbLabView.Items.Count-1 do begin
    s:='';
    if(aLab[i].sVideoId<>'') then s:='Video: https://www.youtube.com/watch?v='+aLab[i].sVideoId+CRLF;
    if(aLab[i].sImgUrl<>'') then begin
      sFile:=GgForm_eId.Text+'_'+IntToStr(i+1)+'.jpg';
      HttpAsk('GET',aLab[i].sImgUrl,'','',sImg);
      StringToFile(sImg,sDir+'\'+sFile);
      s:=s+'Obrzek: '+sFile+CRLF;
    end;
    if(aLab[i].sMessageAward<>'') then s:=s+'Zprava po spravn odpovdi: '+aLab[i].sMessageAward+CRLF;
    if(aLab[i].sVideoIdAward<>'') then s:=s+'Video po otazce: https://www.youtube.com/watch?v='+aLab[i].sVideoIdAward+CRLF;
    if(aLab[i].sImgUrlAward<>'') then begin
      sFile:=GgForm_eId.Text+'_'+IntToStr(i+1)+'po.jpg';
      HttpAsk('GT',aLab[i].sImgUrlAward,'','',sImg);
      StringToFile(sImg,sDir+'\'+sFile);
      s:=s+'Obrzek po otazce: '+sFile+CRLF;
    end;
    sText:=sText+IntToStr(i+1)+'. '+aLab[i].sName+CRLF
      +'Souadnice: '+aLab[i].sCoord+CRLF
      +s   //video a obrazek
      +'Popis: '+Trim(aLab[i].sText)+CRLF
      +'Otzka: '+aLab[i].sQuestion+CRLF+CRLF;
  end;
  StringToFile(sText,sDir+'\Popis.txt');
  if(sender<>nil) then (sender as TBUTTON).Cursor:=crDefault;
  ShowMessage('Uloeno do: '+sDir);
end;

procedure butChangeGpxOnClick(sender:TObject);
var s:string;
begin
  //nastavime priznaky duvodu pro vydani noveho GPX souboru
  s:=GgForm_eChangeGpx.Text;
  GgFlags_bGc.Checked:=(Pos('GC',s)>0);
  GgFlags_bName.Checked:=(Pos('NAME',s)>0);
  GgFlags_bNum.Checked:=(Pos('NUM',s)>0);
  GgFlags_bOrd.Checked:=(Pos('ORD',s)>0);
  GgFlags_bCoord.Checked:=(Pos('COORD',s)>0);
  GgFlags_bText.Checked:=(Pos('TXT',s)>0);
  GgFlags_bSeq.Checked:=(Pos('SEQ',s)>0);
  GgFlags_bEvnt.Checked:=(Pos('EVNT',s)>0);
  GgFlags_bBon.Checked:=(Pos('BON',s)>0);
  GgFlags_bArch.Checked:=(Pos('ARCH',s)>0);
  GgFlags_bSmart.Checked:=(Pos('SMART',s)>0);
  GgFlags_bLink.Checked:=(Pos('LINK',s)>0);
  GgFlags_bOther.Checked:=(Pos('???',s)>0);
  if(GgFlags.ShowModal()<>1) then exit;
  s:='';
  if(GgFlags_bGc.Checked) then s:=s+'GC'+CRLF;
  if(GgFlags_bName.Checked) then s:=s+'NAME'+CRLF;
  if(GgFlags_bNum.Checked) then s:=s+'NUM'+CRLF;
  if(GgFlags_bOrd.Checked) then s:=s+'ORD'+CRLF;
  if(GgFlags_bCoord.Checked) then s:=s+'COORD'+CRLF;
  if(GgFlags_bText.Checked) then s:=s+'TXT'+CRLF;
  if(GgFlags_bSeq.Checked) then s:=s+'SEQ'+CRLF;
  if(GgFlags_bEvnt.Checked) then s:=s+'EVNT'+CRLF;
  if(GgFlags_bBon.Checked) then s:=s+'BON'+CRLF;
  if(GgFlags_bArch.Checked) then s:=s+'ARCH'+CRLF;
  if(GgFlags_bSmart.Checked) then s:=s+'SMART'+CRLF;
  if(GgFlags_bLink.Checked) then s:=s+'LINK'+CRLF;
  if(GgFlags_bOther.Checked) then s:=s+'???'+CRLF;
  GgForm_eChangeGpx.Text:=ReplaceString(Trim(s),CRLF,',');
end;

procedure butDataForMapOnClick(sender:TObject);
var sSql,sCsv:string;
    aList:TStringList;
begin
//vytvori CSV soubor LabId; <dokonceno 1=ano/2=nemenit>; <vlastni 0=ne/1=ano>
  //nepredpokladam, ze by dokoncene byly i vlastni. Pokud ano, pak bude v souboru serie 2x
  aList:=TStringList.Create();
  //seznam dokoncenych serii (predpokladame jen GCxxxxx-*, neumi zpracovat serie A*, B*, ...)
  // to je zjednoduseni, proto vyhledavat musime podle LabId
  sSql:='SELECT LabId_1 FROM'+CRLF
    +'(SELECT gtv.value LabId_1, count(gtv.value) celkem FROM'+CRLF
    +'geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
    +'WHERE gt.id=gc.id AND gc.cachetype="Lab Cache"'+CRLF
    +'  AND gtc.key=gt.ptrkat AND gtc.value="LABid" AND gtv.key=gt.ptrvalue'+CRLF
    +'GROUP BY gtv.value) suma,'+CRLF
    +'(SELECT gtv.value LabId_2, count(gtv.value) odloveno FROM'+CRLF
    +'geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
    +'WHERE gt.id=gc.id AND gc.dtfound>0 AND gc.cachetype="Lab Cache"'+CRLF
    +'  AND gtc.key=gt.ptrkat AND gtc.value="LABid" AND gtv.key=gt.ptrvalue'+CRLF
    +'GROUP BY gtv.value)'+CRLF
    +'WHERE LabId_1=LabId_2 AND celkem=odloveno';
  GEOGET_DB.GetTableStrings(sSql,aList);
  //GC kod serie;priznak dokonceni; priznak vlastni serie
  sCsv:=ReplaceString(aList.Text,CRLF,';1;0'+CRLF);
  sSql:='SELECT gtv.value FROM'+CRLF
    +'geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'+CRLF
    +'WHERE gt.id=gc.id AND gc.author="'+GEOGET_OWNER+'" AND gc.cachetype="Lab Cache"'+CRLF
    +'  AND gtc.key=gt.ptrkat AND gtc.value="LABid" AND gtv.key=gt.ptrvalue'+CRLF
    +'GROUP BY gtv.value';
  GEOGET_DB.GetTableStrings(sSql,aList);
  //tady by 2 mela byt brana jako "ponechat puvodni hodnotu"
  sCsv:=sCsv+ReplaceString(aList.Text,CRLF,';2;1'+CRLF);
  aList.Free();
  if(KESKOMAPA_CUSTOMFILE='') then sSql:=GetMyDir()+'Keskomapa.csv'
  else sSql:=KESKOMAPA_CUSTOMFILE;
  sCsv:=sSql+CRLF+sCsv;
  StringToFile(sCsv,sSql);
  ShowMessage('Vytvoen soubor s osobnmi daty pro kekomapu:'+CRLF+CRLF+sSql);
end;

procedure butGpxImportOnClick(sender:TObject);
var sFile:string;
begin
  //nechame vybrat gpx soubor
  if(not OpenDlg('GPX soubor se sri LABek', GetMyDir(), '', 'GPX soubor (*.gpx)|*.gpx',sFile)) then exit;
  ProtStart();
  GeoImportBegin();
  GEOGET_DB.Start('LabForGg','');
  ImportGpxFile(sFile);
  GEOGET_DB.Commit('LabForGg');
  GeoImportEnd();
  ProtEnd();
end;

procedure butNameApiCopyOnClick(sender:TObject);
var s:string;
begin
  //zobrazime druhou hodnotu jmena a tu puvodne zobrazenou si zapamatujeme,
  //aby ji zase slo vratit
  s:=GgForm_eName.Text;
  GgForm_eName.Text:=GgForm_eNameApi.Text;
  GgForm_eNameApi.Text:=s;
end;

procedure butUpdateByGgListOnClick(sender:TObject);
var s,sId,sSql,sFile,sIds:string;
    aList:TStringList;
    g:TGeo;
begin
  GeoBusyStart();
  GeoBusyCaption('Priprava LabId ...');
  sFile:=GetOfflineDir()+'list.ggt';
  //nacteme seznam vsech kesi a vyhledame pro ne LabId
  GeoListSave(sFile);
  //ted vybereme jen ty vybrane
  if(FileExists(sFile)) then begin
    s:=trim(FileToString(sFile));
    while(s<>'') do begin
      sId:=fetch(s,CRLF);
      g:=TGeo.Create(); //pro vypnuti optimalizace musime vzdy vytvaret instanci znovu
      g.id:=sId;
      if(g.IsSelected()) then sIds:=sIds+CRLF+sId;
      g.Free();
    end;
    DeleteFiles(sFile);
  end;
  //pro vybrane kese najdeme seznam LabId (jedinecne i kdyz jsou vybrane vsechny
  //kese z jedne serie)
  if(sIds<>'') then begin
    sIds:='"'+ReplaceString(Trim(sIds),CRLF,'","')+'"';
    {$ifdef DEBUG_HELPER} LDH('Seznam kesi: '+sIds); {$endif}
    sSql:='SELECT distinct(gtv.value) celkem FROM geotag gt, geotagcategory gtc, geotagvalue gtv '
         +'  WHERE gt.id IN ('+sIds+') '
         +'    AND gtc.key=gt.ptrkat AND gtc.value="LABid" AND gtv.key=gt.ptrvalue';
    aList:=TStringList.Create();
    GEOGET_DB.GetTableStrings(sSql,aList);
    sIds:=Trim(ReplaceString(Trim(aList.Text),CRLF,','));
    aList.Free();
    {$ifdef DEBUG_HELPER} LDH('Seznam LabId: '+sIds); {$endif}
  end;
  if(sIds='') then begin
    ShowMessage('Neni vybrana zadna serie LAB kesi');
    exit;
  end;
{$ifdef DEBUG_HELPER} LDH('Seznam pozadovanych LabId: '+sIds); {$endif}
  DownloadAndImportList(sIds,true); //stahnem a hned importujem
end;
